## creduce 2.4.0

=== CMakeLists.txt ===
# Copyright (c) 2012, 2013, 2014, 2015 The University of Utah
# All rights reserved.
#
# This file is distributed under the University of Illinois Open Source
# License.  See the file COPYING for details.

cmake_minimum_required(VERSION 2.8.12)
project(creduce)

include(CheckIncludeFile)
#include(CheckPrototypeExists)

# Generate config.h
set(ENABLE_TRANS_ASSERT ON CACHE BOOL "Use assert() in clang_delta transformations.")

check_include_file("dlfcn.h" HAVE_DLFCN_H)
check_include_file("inttypes.h" HAVE_INTTYPES_H)
check_include_file("memory.h" HAVE_MEMORY_H)
check_include_file("stdint.h" HAVE_STDINT_H)
check_include_file("stdlib.h" HAVE_STDLIB_H)
check_include_file("strings.h" HAVE_STRINGS_H)
check_include_file("string.h" HAVE_STRING_H)
check_include_file("sys/stat.h" HAVE_SYS_STAT_H)
check_include_file("sys/types.h" HAVE_SYS_TYPES_H)
check_include_file("unistd.h" HAVE_UNISTD_H)

set(creduce_PACKAGE "creduce")
set(creduce_PACKAGE_BUGREPORT "creduce-bugs@flux.utah.edu")
set(creduce_PACKAGE_NAME "creduce")
set(creduce_PACKAGE_STRING "creduce 2.4.0")
set(creduce_PACKAGE_TARNAME "creduce")
set(creduce_PACKAGE_URL "http://embed.cs.utah.edu/creduce/")
set(creduce_PACKAGE_VERSION "2.4.0")
set(creduce_VERSION "2.4.0")

execute_process(COMMAND "git" "show" "-s" "--format=%h" WORKING_DIRECTORY "${CMAKE_SOURCE_DIR}" OUTPUT_VARIABLE creduce_GIT_HASH)
string(STRIP "${creduce_GIT_HASH}" creduce_GIT_HASH)

#check_prototype_exists(free stdlib.h freeExists)
#if(freeExists)
#    set(STDC_HEADERS 1)
#endif(freeExists)

if(CMAKE_CXX_COMPILER_ID STREQUAL "GNU" OR CMAKE_CXX_COMPILER_ID STREQUAL "Clang")
  set(CMAKE_CXX_FLAGS "-std=c++11 -fno-rtti -Wall -Wextra -Wno-long-long -Wno-unused-parameter")
  set(CMAKE_CXX_FLAGS_RELEASE "-O3 -fno-strict-aliasing")
endif()

#FIXME: Should be determined automatically
set(YYTEXT_POINTER 1)

configure_file("cmake_config.h.in" "${PROJECT_BINARY_DIR}/config.h")

add_subdirectory(creduce)
add_subdirectory(clang_delta)
add_subdirectory(clex)

## creduce 2.0.1

=== debian/changelog ===
creduce (2.0.1-1) experimental; urgency=low

  * Initial release. Closes: #678645.

 -- Matthias Klose <doko@debian.org>  Tue, 15 Jan 2013 17:23:23 +0100

=== debian/control ===
Source: creduce
Section: devel
Priority: extra
Maintainer: Debian GCC Maintainers <debian-gcc@lists.debian.org>
Uploaders: Matthias Klose <doko@debian.org>
Build-Depends: debhelper (>= 8.0.0), autotools-dev,
  llvm-3.2-dev, libclang-dev (>= 3.2),
  clang (>= 3.2),
  libbenchmark-timer-perl, libsys-cpu-perl,
  libfile-which-perl, libregexp-common-perl, libexporter-lite-perl,
  indent, astyle, delta
Standards-Version: 3.9.4
Homepage: http://embed.cs.utah.edu/creduce/

Package: creduce
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends},
  libbenchmark-timer-perl, libsys-cpu-perl,
  libfile-which-perl, libregexp-common-perl, libexporter-lite-perl,
  indent, astyle, delta
Recommends: gcc | clang
Description: Test-Case Reduction for C Compiler Bugs
 C-Reduce is a tool which takes a large C or C++ program that has a
 property of interest (such as triggering a compiler bug) and
 automatically produces a much smaller C/C++ program that has the same
 property.  It is intended for use by people who discover and report
 bugs in compilers and other tools that process C/C++ code.

=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-

# Uncomment this to turn on verbose mode.
#export DH_VERBOSE=1

DEB_HOST_ARCH := $(shell dpkg-architecture -qDEB_HOST_ARCH)

%:
	dh $@  --with autotools-dev --parallel

override_dh_auto_configure:
	dh_auto_configure -- --with-llvm=/usr/lib/llvm-3.2
	
override_dh_auto_test:
# these are time consuming ...
ifneq (,$(filter $(DEB_HOST_ARCH),amd64 i386 x32))
	cd tests && ./run_tests
endif

override_dh_auto_clean:
	rm -rf tests/tmp_*
	dh_auto_clean

## creduce 2.1.0

=== debian/changelog ===
creduce (2.1.0-1) unstable; urgency=low

  * New upstream version.

 -- Matthias Klose <doko@debian.org>  Fri, 01 Nov 2013 23:16:35 +0200

creduce (2.0.1-3) unstable; urgency=low

  * Fix a crash, taken from the trunk.

 -- Matthias Klose <doko@debian.org>  Fri, 05 Apr 2013 13:25:28 +0200

=== debian/control ===
--- 
+++ 
@@ -4,10 +4,11 @@
 Maintainer: Debian GCC Maintainers <debian-gcc@lists.debian.org>
 Uploaders: Matthias Klose <doko@debian.org>
 Build-Depends: debhelper (>= 8.0.0), autotools-dev,
-  llvm-3.2-dev, libclang-dev (>= 3.2),
-  clang (>= 3.2),
+  llvm-3.3-dev, libclang-3.3-dev,
+  clang-3.3,
   libbenchmark-timer-perl, libsys-cpu-perl,
   libfile-which-perl, libregexp-common-perl, libexporter-lite-perl,
+  libgetopt-tabular-perl,
   indent, astyle, delta
 Standards-Version: 3.9.4
 Homepage: http://embed.cs.utah.edu/creduce/
@@ -17,6 +18,7 @@
 Depends: ${shlibs:Depends}, ${misc:Depends},
   libbenchmark-timer-perl, libsys-cpu-perl,
   libfile-which-perl, libregexp-common-perl, libexporter-lite-perl,
+  libgetopt-tabular-perl,
   indent, astyle, delta
 Recommends: gcc | clang
 Description: Test-Case Reduction for C Compiler Bugs

=== debian/rules ===
--- 
+++ 
@@ -10,7 +10,7 @@
 	dh $@  --with autotools-dev --parallel
 
 override_dh_auto_configure:
-	dh_auto_configure -- --with-llvm=/usr/lib/llvm-3.2
+	dh_auto_configure -- --with-llvm=/usr/lib/llvm-3.3
 	
 override_dh_auto_test:
 # these are time consuming ...

## creduce 2.2~pre1

=== debian/changelog ===
creduce (2.2~pre1-2) unstable; urgency=medium

  * Build-depend on flex.

 -- Matthias Klose <doko@debian.org>  Thu, 27 Mar 2014 14:01:12 +0100

creduce (2.2~pre1-1) unstable; urgency=medium

  * New upstream snapshot (trunk 20140327).
  * Build using llvm-3.4.

 -- Matthias Klose <doko@debian.org>  Thu, 27 Mar 2014 12:00:43 +0100

=== debian/control ===
--- 
+++ 
@@ -4,18 +4,20 @@
 Maintainer: Debian GCC Maintainers <debian-gcc@lists.debian.org>
 Uploaders: Matthias Klose <doko@debian.org>
 Build-Depends: debhelper (>= 8.0.0), autotools-dev,
-  llvm-3.3-dev, libclang-3.3-dev,
-  clang-3.3,
+  flex,
+  llvm-3.4-dev, libclang-3.4-dev,
+  clang-3.4, clang-format-3.4,
   libbenchmark-timer-perl, libsys-cpu-perl,
   libfile-which-perl, libregexp-common-perl, libexporter-lite-perl,
   libgetopt-tabular-perl,
   indent, astyle, delta
-Standards-Version: 3.9.4
+Standards-Version: 3.9.5
 Homepage: http://embed.cs.utah.edu/creduce/
 
 Package: creduce
 Architecture: any
 Depends: ${shlibs:Depends}, ${misc:Depends},
+  clang-format-3.4,
   libbenchmark-timer-perl, libsys-cpu-perl,
   libfile-which-perl, libregexp-common-perl, libexporter-lite-perl,
   libgetopt-tabular-perl,

=== debian/rules ===
--- 
+++ 
@@ -10,7 +10,7 @@
 	dh $@  --with autotools-dev --parallel
 
 override_dh_auto_configure:
-	dh_auto_configure -- --with-llvm=/usr/lib/llvm-3.3
+	dh_auto_configure -- --with-llvm=/usr/lib/llvm-3.4 CLANG_FORMAT=clang-format-3.4
 	
 override_dh_auto_test:
 # these are time consuming ...

## creduce 2.2~pre3

=== debian/changelog ===
creduce (2.2~pre3-3) unstable; urgency=medium

  * Bump dependency on clang-format-3.x.
  * Drop the unversioned build dependency on clang, and allow the
    tests to use a versioned clang-x.y binary.
  * Build-depend on frama-c-base.

 -- Matthias Klose <doko@debian.org>  Tue, 12 Aug 2014 14:46:13 +0200

creduce (2.2~pre3-2) unstable; urgency=medium

  * Build-depend on libedit-dev and zlib1g-dev, missing dependencies
    of llvm-3.5-dev.

 -- Matthias Klose <doko@debian.org>  Mon, 11 Aug 2014 18:56:34 +0200

creduce (2.2~pre3-1) unstable; urgency=medium

  * New upstream snapshot (llvm-svn-compatible 20140811).
  * Build using llvm-3.5-dev and libclang-3.5-dev.

 -- Matthias Klose <doko@debian.org>  Mon, 11 Aug 2014 14:04:49 +0200

creduce (2.2~pre2-1) unstable; urgency=medium

  * New upstream snapshot (trunk 20140811).

 -- Matthias Klose <doko@debian.org>  Mon, 11 Aug 2014 13:37:15 +0200

## creduce 2.2.1

=== debian/changelog ===
creduce (2.2.1-1~14.04) trusty-proposed; urgency=medium

  * Build for trusty, using llvm-3.5 on all architectures. LP: #1426725.

 -- Matthias Klose <doko@ubuntu.com>  Sat, 28 Feb 2015 17:23:40 +0100

creduce (2.2.1-1) unstable; urgency=medium

  * C-Reduce 2.2.1 release.

 -- Matthias Klose <doko@debian.org>  Fri, 10 Oct 2014 09:51:25 +0200

=== debian/control ===
--- 
+++ 
@@ -5,19 +5,24 @@
 Uploaders: Matthias Klose <doko@debian.org>
 Build-Depends: debhelper (>= 8.0.0), autotools-dev,
   flex,
-  llvm-3.4-dev, libclang-3.4-dev,
-  clang-3.4, clang-format-3.4,
+  libedit-dev, zlib1g-dev,
+  llvm-3.5-dev, libclang-3.5-dev,
+  clang-3.5, clang-format-3.5,
   libbenchmark-timer-perl, libsys-cpu-perl,
   libfile-which-perl, libregexp-common-perl, libexporter-lite-perl,
   libgetopt-tabular-perl,
-  indent, astyle, delta
+  indent, astyle, delta,
+# for running the tests:
+  frama-c-base,
+# wrong kcc, https://code.google.com/p/c-semantics/ is needed
+Build-Conflicts: kcc
 Standards-Version: 3.9.5
 Homepage: http://embed.cs.utah.edu/creduce/
 
 Package: creduce
 Architecture: any
 Depends: ${shlibs:Depends}, ${misc:Depends},
-  clang-format-3.4,
+  clang-format-3.5,
   libbenchmark-timer-perl, libsys-cpu-perl,
   libfile-which-perl, libregexp-common-perl, libexporter-lite-perl,
   libgetopt-tabular-perl,

=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-

# Uncomment this to turn on verbose mode.
#export DH_VERBOSE=1

DEB_HOST_ARCH := $(shell dpkg-architecture -qDEB_HOST_ARCH)

CLANG_V	= 3.5
CLANG	= clang-$(CLANG_V)
GCC	= gcc

%:
	dh $@  --with autotools-dev --parallel

override_dh_auto_configure:
	dh_auto_configure -- --with-llvm=/usr/lib/llvm-$(CLANG_V) CLANG_FORMAT=clang-format-$(CLANG_V)
	
override_dh_auto_test:
# these are time consuming ...
ifneq (,$(filter $(DEB_HOST_ARCH),amd64 i386 x32 ppc64 ppc64el))
	cd tests && CLANG="$(CLANG)" GCC="$(GCC)" ./run_tests
endif

override_dh_auto_clean:
	rm -rf tests/tmp_*
	dh_auto_clean

## creduce 2.3.0

=== debian/changelog ===
creduce (2.3.0-0ubuntu1) wily; urgency=medium

  * C-Reduce 2.3.0 release.
  * Build using llvm-3.6.

 -- Matthias Klose <doko@ubuntu.com>  Sat, 08 Aug 2015 13:22:58 +0200

=== debian/control ===
--- 
+++ 
@@ -6,8 +6,8 @@
 Build-Depends: debhelper (>= 8.0.0), autotools-dev,
   flex,
   libedit-dev, zlib1g-dev,
-  llvm-3.5-dev, libclang-3.5-dev,
-  clang-3.5, clang-format-3.5,
+  llvm-3.6-dev, libclang-3.6-dev,
+  clang-3.6, clang-format-3.6,
   libbenchmark-timer-perl, libsys-cpu-perl,
   libfile-which-perl, libregexp-common-perl, libexporter-lite-perl,
   libgetopt-tabular-perl,
@@ -16,13 +16,13 @@
   frama-c-base,
 # wrong kcc, https://code.google.com/p/c-semantics/ is needed
 Build-Conflicts: kcc
-Standards-Version: 3.9.5
+Standards-Version: 3.9.6
 Homepage: http://embed.cs.utah.edu/creduce/
 
 Package: creduce
 Architecture: any
 Depends: ${shlibs:Depends}, ${misc:Depends},
-  clang-format-3.5,
+  clang-format-3.6,
   libbenchmark-timer-perl, libsys-cpu-perl,
   libfile-which-perl, libregexp-common-perl, libexporter-lite-perl,
   libgetopt-tabular-perl,

=== debian/rules ===
--- 
+++ 
@@ -6,7 +6,7 @@
 
 DEB_HOST_ARCH := $(shell dpkg-architecture -qDEB_HOST_ARCH)
 
-CLANG_V	= 3.5
+CLANG_V	= 3.6
 CLANG	= clang-$(CLANG_V)
 GCC	= gcc
 
@@ -18,7 +18,7 @@
 	
 override_dh_auto_test:
 # these are time consuming ...
-ifneq (,$(filter $(DEB_HOST_ARCH),amd64 i386 x32 ppc64 ppc64el))
+ifneq (,$(filter $(DEB_HOST_ARCH),armhf arm64 amd64 i386 x32 powerpc ppc64 ppc64el))
 	cd tests && CLANG="$(CLANG)" GCC="$(GCC)" ./run_tests
 endif

## creduce 2.4.0

=== debian/changelog ===
creduce (2.4.0-1) unstable; urgency=medium

  * C-Reduce 2.4.0 release.
  * Build using llvm-3.7.
  * (Build-)depend on libterm-readkey-perl.
  * Prepare to build using llvm-3.8 (from the llvm-svn-compatible branch).

 -- Matthias Klose <doko@debian.org>  Sat, 05 Dec 2015 07:39:22 +0100

creduce (2.3.0-1) unstable; urgency=medium

  * C-Reduce 2.3.0 release.
  * Build using llvm-3.6.

 -- Matthias Klose <doko@debian.org>  Sat, 08 Aug 2015 13:22:58 +0200

=== debian/control ===
--- 
+++ 
@@ -3,18 +3,17 @@
 Priority: extra
 Maintainer: Debian GCC Maintainers <debian-gcc@lists.debian.org>
 Uploaders: Matthias Klose <doko@debian.org>
-Build-Depends: debhelper (>= 8.0.0), autotools-dev,
+Build-Depends: debhelper (>= 9), autotools-dev,
   flex,
   libedit-dev, zlib1g-dev,
-  llvm-3.6-dev, libclang-3.6-dev,
-  clang-3.6, clang-format-3.6,
+  llvm-3.7-dev, libclang-3.7-dev,
+  clang-3.7, clang-format-3.7,
   libbenchmark-timer-perl, libsys-cpu-perl,
   libfile-which-perl, libregexp-common-perl, libexporter-lite-perl,
-  libgetopt-tabular-perl,
+  libgetopt-tabular-perl, libterm-readkey-perl,
   indent, astyle, delta,
 # for running the tests:
-  frama-c-base,
-# wrong kcc, https://code.google.com/p/c-semantics/ is needed
+  frama-c-base
 Build-Conflicts: kcc
 Standards-Version: 3.9.6
 Homepage: http://embed.cs.utah.edu/creduce/
@@ -22,10 +21,10 @@
 Package: creduce
 Architecture: any
 Depends: ${shlibs:Depends}, ${misc:Depends},
-  clang-format-3.6,
+  clang-format-3.7,
   libbenchmark-timer-perl, libsys-cpu-perl,
   libfile-which-perl, libregexp-common-perl, libexporter-lite-perl,
-  libgetopt-tabular-perl,
+  libgetopt-tabular-perl, libterm-readkey-perl,
   indent, astyle, delta
 Recommends: gcc | clang
 Description: Test-Case Reduction for C Compiler Bugs

=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-

# Uncomment this to turn on verbose mode.
#export DH_VERBOSE=1

DEB_HOST_ARCH := $(shell dpkg-architecture -qDEB_HOST_ARCH)

CLANG_V	= 3.7
CLANG	= clang-$(CLANG_V)
GCC	= gcc

%:
	dh $@  --with autotools-dev --parallel

override_dh_auto_configure:
	dh_auto_configure -- --with-llvm=/usr/lib/llvm-$(CLANG_V) CLANG_FORMAT=clang-format-$(CLANG_V)
	
override_dh_auto_build:
	dh_auto_build

ifeq ($(DEB_HOST_ARCH),$(DEB_BUILD_ARCH))
	if which help2man >/dev/null 2>&1; then \
	  v=$$(creduce/creduce --help| awk '/^creduce/ { print $$2 }'); \
	  help2man --name='C and C++ program reducer' --version-string=$$v creduce/creduce > debian/creduce.1; \
	fi
endif

override_dh_auto_test:
# these are time consuming ...
ifeq (,$(findstring nocheck, $(DEB_BUILD_OPTIONS)))
  ifeq (,$(filter $(DEB_HOST_ARCH),m68k sh4 s390 sparc))
	cd tests && CLANG="$(CLANG)" GCC="$(GCC)" ./run_tests
  endif
endif

override_dh_auto_install:
	dh_auto_install
	install -D -m 644 debian/creduce.1 debian/creduce/usr/share/man/man1/creduce.1

override_dh_auto_clean:
	rm -rf tests/tmp_*
	dh_auto_clean

## creduce 2.5~20160312

=== debian/changelog ===
creduce (2.5~20160312-1) unstable; urgency=medium

  * Upstream snapshot, taken from master.

 -- Matthias Klose <doko@debian.org>  Sat, 12 Mar 2016 11:06:08 +0100

creduce (2.4.0-12) experimental; urgency=medium

  * Update to the llvm-svn-compatible branch.
  * Build using llvm-3.8.

 -- Matthias Klose <doko@debian.org>  Wed, 03 Feb 2016 13:56:20 +0100

creduce (2.4.0-11) experimental; urgency=medium

  * C-Reduce 2.4.0 release.
  * Update to the llvm-svn-compatible branch.
  * Build using llvm-3.8.
  * (Build-)depend on libterm-readkey-perl.

 -- Matthias Klose <doko@debian.org>  Sat, 05 Dec 2015 02:07:34 +0100

## creduce 2.5~20160420

=== clang_delta/CMakeLists.txt ===
# Copyright (c) 2012, 2013, 2014, 2015 The University of Utah
# All rights reserved.
#
# This file is distributed under the University of Illinois Open Source
# License.  See the file COPYING for details.

cmake_minimum_required(VERSION 2.8.12)
project(clang_delta)

# Find LLVM
find_package(LLVM REQUIRED CONFIG NO_CMAKE_BUILDS_PATH)
message(STATUS "Found LLVM ${LLVM_PACKAGE_VERSION}")
message(STATUS "Using LLVMConfig.cmake in: ${LLVM_DIR}")

# Check LLVM version
if (${LLVM_PACKAGE_VERSION} VERSION_LESS "3.7")
  message(FATAL_ERROR "LLVM version must be >= 3.7")
endif()
set(LLVM_VERSION ${LLVM_VERSION_MAJOR}${LLVM_VERSION_MINOR})

# Add flags for LLVM
add_definitions(${LLVM_DEFINITIONS})
set_property(DIRECTORY APPEND PROPERTY COMPILE_DEFINITIONS HAVE_CONFIG_H
  $<$<CONFIG:Release>:NDEBUG> $<$<CONFIG:Debug>:ENABLE_TRANS_ASSERT>)
include_directories(${LLVM_INCLUDE_DIRS})
include_directories(${CMAKE_BINARY_DIR})
link_directories(${LLVM_LIBRARY_DIRS})

llvm_map_components_to_libnames(LLVM_LIBS
  irreader
  mcparser
  option
)

set(CLANG_LIBS
  clangRewrite
  clangFrontend
  clangParse
  clangSema
  clangSerialization
  clangAnalysis
  clangEdit
  clangLex
  clangAST
  clangDriver
  clangBasic
)

set(TRANSFORMATION_HEADERS
  AggregateToScalar.h
  BinOpSimplification.h
  CallExprToValue.h
  ClassTemplateToClass.h
  CombineGlobalVarDecl.h
  CombineLocalVarDecl.h
  CommonParameterRewriteVisitor.h
  CommonRenameClassRewriteVisitor.h
  CommonStatementVisitor.h
  CommonTemplateArgumentVisitor.h
  CopyPropagation.h
  EmptyStructToInt.h
  InstantiateTemplateParam.h
  InstantiateTemplateTypeParamToInt.h
  LiftAssignmentExpr.h
  LocalToGlobal.h
  MoveFunctionBody.h
  MoveGlobalVar.h
  ParamToGlobal.h
  ParamToLocal.h
  ReduceArrayDim.h
  ReduceArraySize.h
  ReduceClassTemplateParameter.h
  ReducePointerLevel.h
  ReducePointerPairs.h
  RemoveAddrTaken.h
  RemoveArray.h
  RemoveBaseClass.h
  RemoveCtorInitializer.h
  RemoveEnumMemberValue.h
  RemoveNamespace.h
  RemoveNestedFunction.h
  RemovePointer.h
  RemoveTrivialBaseTemplate.h
  RemoveUnresolvedBase.h
  RemoveUnusedEnumMember.h
  RemoveUnusedFunction.h
  RemoveUnusedOuterClass.h
  RemoveUnusedStructField.h
  RemoveUnusedVar.h
  RenameCXXMethod.h
  RenameClass.h
  RenameFun.h
  RenameParam.h
  RenameVar.h
  ReplaceArrayIndexVar.h
  ReplaceCallExpr.h
  ReplaceClassWithBaseTemplateSpec.h
  ReplaceDependentName.h
  ReplaceDependentTypedef.h
  ReplaceDerivedClass.h
  ReplaceFunctionDefWithDecl.h
  ReplaceOneLevelTypedefType.h
  ReplaceSimpleTypedef.h
  ReplaceUndefinedFunction.h
  ReturnVoid.h
  SimpleInliner.h
  SimplifyCallExpr.h
  SimplifyCommaExpr.h
  SimplifyDependentTypedef.h
  SimplifyIf.h
  SimplifyNestedClass.h
  SimplifyRecursiveTemplateInstantiation.h
  SimplifyStruct.h
  SimplifyStructUnionDecl.h
  TemplateArgToInt.h
  TemplateNonTypeArgToInt.h
  UnifyFunctionDecl.h
  UnionToStruct.h
)

set(TRANSFORMATION_SOURCES
  AggregateToScalar.cpp
  BinOpSimplification.cpp
  CallExprToValue.cpp
  ClassTemplateToClass.cpp
  CombineGlobalVarDecl.cpp
  CombineLocalVarDecl.cpp
  CopyPropagation.cpp
  EmptyStructToInt.cpp
  InstantiateTemplateParam.cpp
  InstantiateTemplateTypeParamToInt.cpp
  LiftAssignmentExpr.cpp
  LocalToGlobal.cpp
  MoveFunctionBody.cpp
  MoveGlobalVar.cpp
  ParamToGlobal.cpp
  ParamToLocal.cpp
  ReduceArrayDim.cpp
  ReduceArraySize.cpp
  ReduceClassTemplateParameter.cpp
  ReducePointerLevel.cpp
  ReducePointerPairs.cpp
  RemoveAddrTaken.cpp
  RemoveArray.cpp
  RemoveBaseClass.cpp
  RemoveCtorInitializer.cpp
  RemoveEnumMemberValue.cpp
  RemoveNamespace.cpp
  RemoveNestedFunction.cpp
  RemovePointer.cpp
  RemoveTrivialBaseTemplate.cpp
  RemoveUnresolvedBase.cpp
  RemoveUnusedEnumMember.cpp
  RemoveUnusedFunction.cpp
  RemoveUnusedOuterClass.cpp
  RemoveUnusedStructField.cpp
  RemoveUnusedVar.cpp
  RenameCXXMethod.cpp
  RenameClass.cpp
  RenameFun.cpp
  RenameParam.cpp
  RenameVar.cpp
  ReplaceArrayIndexVar.cpp
  ReplaceCallExpr.cpp
  ReplaceClassWithBaseTemplateSpec.cpp
  ReplaceDependentName.cpp
  ReplaceDependentTypedef.cpp
  ReplaceDerivedClass.cpp
  ReplaceFunctionDefWithDecl.cpp
  ReplaceOneLevelTypedefType.cpp
  ReplaceSimpleTypedef.cpp
  ReplaceUndefinedFunction.cpp
  ReturnVoid.cpp
  SimpleInliner.cpp
  SimplifyCallExpr.cpp
  SimplifyCommaExpr.cpp
  SimplifyDependentTypedef.cpp
  SimplifyIf.cpp
  SimplifyNestedClass.cpp
  SimplifyRecursiveTemplateInstantiation.cpp
  SimplifyStruct.cpp
  SimplifyStructUnionDecl.cpp
  TemplateArgToInt.cpp
  TemplateNonTypeArgToInt.cpp
  UnifyFunctionDecl.cpp
  UnionToStruct.cpp
)

add_executable(clang_delta
  ${CMAKE_BINARY_DIR}/config.h
  ${TRANSFORMATION_HEADERS}
  ${TRANSFORMATION_SOURCES}
  RewriteUtils.h
  Transformation.h
  TransformationManager.h
  ClangDelta.cpp
  RewriteUtils.cpp
  Transformation.cpp
  TransformationManager.cpp
)

target_link_libraries(clang_delta ${CLANG_LIBS} ${LLVM_LIBS})

install(TARGETS clang_delta
  RUNTIME DESTINATION "bin"
)

=== clex/CMakeLists.txt ===
# Copyright (c) 2012, 2013, 2014, 2015 The University of Utah
# All rights reserved.
#
# This file is distributed under the University of Illinois Open Source
# License.  See the file COPYING for details.

cmake_minimum_required(VERSION 2.8.12)
find_package(FLEX)

project(clex)
include_directories(${PROJECT_SOURCE_DIR})
include_directories(${CMAKE_BINARY_DIR})
add_definitions(-DHAVE_CONFIG_H)

FLEX_TARGET(clex_scanner clex.l ${PROJECT_BINARY_DIR}/clex.c)

add_executable(clex
  defs.h
  driver.c
  ${FLEX_clex_scanner_OUTPUTS}
)

project(strlex)
include_directories(${PROJECT_SOURCE_DIR})
include_directories(${CMAKE_BINARY_DIR})
add_definitions(-DHAVE_CONFIG_H)

FLEX_TARGET(strlex_scanner strlex.l ${PROJECT_BINARY_DIR}/strlex.c)

add_executable(strlex
  defs.h
  driver.c
  ${FLEX_strlex_scanner_OUTPUTS}
)

install(TARGETS clex strlex
  RUNTIME DESTINATION "bin"
)

=== creduce/CMakeLists.txt ===
# Copyright (c) 2012, 2013, 2014, 2015 The University of Utah
# All rights reserved.
#
# This file is distributed under the University of Illinois Open Source
# License.  See the file COPYING for details.

cmake_minimum_required(VERSION 2.8.12)
project(creduce_perl)

include(FindPerl)

find_program(ASTYLE "astyle${CMAKE_EXECUTABLE_SUFFIX}")
if(NOT ASTYLE)
message(WARNING "astyle${CMAKE_EXECUTABLE_SUFFIX} could not be found! Set ASTYLE manually.")
endif(NOT ASTYLE)

find_program(CLANG_FORMAT "clang-format${CMAKE_EXECUTABLE_SUFFIX}")
if(NOT CLANG_FORMAT)
message(WARNING "clang-format${CMAKE_EXECUTABLE_SUFFIX} could not be found! Set CLANG_FORMAT manually.")
endif(NOT CLANG_FORMAT)

find_program(INDENT "indent${CMAKE_EXECUTABLE_SUFFIX}")
if(NOT INDENT)
message(WARNING "indent${CMAKE_EXECUTABLE_SUFFIX} could not be found! Set INDENT manually.")
endif(NOT INDENT)

find_program(TOPFORMFLAT "topformflat${CMAKE_EXECUTABLE_SUFFIX}")
if(NOT TOPFORMFLAT)
message(WARNING "topformflat${CMAKE_EXECUTABLE_SUFFIX} could not be found! Set TOPFORMFLAT manually.")
endif(NOT TOPFORMFLAT)

# Prepare creduce.pl
file(READ "creduce.in" CREDUCE_CONTENT)
string(REGEX REPLACE "\@perl\@" "${PERL_EXECUTABLE}" CREDUCE_CONTENT "${CREDUCE_CONTENT}")
string(REGEX REPLACE "\@PERL\@" "${PERL_EXECUTABLE}" CREDUCE_CONTENT "${CREDUCE_CONTENT}")
string(REGEX REPLACE "\@perllibdir\@" "${CMAKE_INSTALL_PREFIX}/modules" CREDUCE_CONTENT "${CREDUCE_CONTENT}")
string(REGEX REPLACE "\@prefix\@" "${CMAKE_INSTALL_PREFIX}" CREDUCE_CONTENT "${CREDUCE_CONTENT}")
file(WRITE "${PROJECT_BINARY_DIR}/creduce.pl" "${CREDUCE_CONTENT}")

# Prepare creduce_config.pm
file(READ "creduce_config.pm.in" CREDUCE_CONTENT)
string(REGEX REPLACE "\@bindir\@" "${CMAKE_INSTALL_PREFIX}" CREDUCE_CONTENT "${CREDUCE_CONTENT}")
string(REGEX REPLACE "\@libexecdir\@" "${CMAKE_INSTALL_PREFIX}/bin" CREDUCE_CONTENT "${CREDUCE_CONTENT}")
string(REGEX REPLACE "\@PACKAGE_BUGREPORT\@" "${creduce_PACKAGE_BUGREPORT}" CREDUCE_CONTENT "${CREDUCE_CONTENT}")
string(REGEX REPLACE "\@PACKAGE_NAME\@" "${creduce_PACKAGE_NAME}" CREDUCE_CONTENT "${CREDUCE_CONTENT}")
string(REGEX REPLACE "\@PACKAGE_STRING\@" "${creduce_PACKAGE_STRING}" CREDUCE_CONTENT "${CREDUCE_CONTENT}")
string(REGEX REPLACE "\@PACKAGE_URL\@" "${creduce_PACKAGE_URL}" CREDUCE_CONTENT "${CREDUCE_CONTENT}")
string(REGEX REPLACE "\@PACKAGE_VERSION\@" "${creduce_PACKAGE_VERSION}" CREDUCE_CONTENT "${CREDUCE_CONTENT}")
string(REGEX REPLACE "\@VERSION\@" "${creduce_VERSION}" CREDUCE_CONTENT "${CREDUCE_CONTENT}")
string(REGEX REPLACE "\@GIT_HASH\@" "${creduce_GIT_HASH}" CREDUCE_CONTENT "${CREDUCE_CONTENT}")
string(REGEX REPLACE "\@ASTYLE\@" "${ASTYLE}" CREDUCE_CONTENT "${CREDUCE_CONTENT}")
string(REGEX REPLACE "\@CLANG_FORMAT\@" "${CLANG_FORMAT}" CREDUCE_CONTENT "${CREDUCE_CONTENT}")
string(REGEX REPLACE "\@INDENT\@" "${INDENT}" CREDUCE_CONTENT "${CREDUCE_CONTENT}")
string(REGEX REPLACE "\@TOPFORMFLAT\@" "${TOPFORMFLAT}" CREDUCE_CONTENT "${CREDUCE_CONTENT}")
file(WRITE "${PROJECT_BINARY_DIR}/modules/creduce_config.pm" "${CREDUCE_CONTENT}")

install(PROGRAMS
  "${PROJECT_BINARY_DIR}/creduce.pl"
  DESTINATION "${CMAKE_INSTALL_PREFIX}"
)

install(DIRECTORY
  "${PROJECT_BINARY_DIR}/modules/"
  DESTINATION "modules"
)

install(DIRECTORY
  "${PROJECT_SOURCE_DIR}/"
  DESTINATION "modules"
  FILES_MATCHING PATTERN "*.pm"
)

=== debian/changelog ===
creduce (2.5~20160420-0ubuntu1) xenial; urgency=medium

  * Upstream snapshot, taken from master.

 -- Matthias Klose <doko@ubuntu.com>  Wed, 20 Apr 2016 13:57:19 +0200

=== debian/control ===
--- 
+++ 
@@ -6,8 +6,8 @@
 Build-Depends: debhelper (>= 9), autotools-dev,
   flex,
   libedit-dev, zlib1g-dev,
-  llvm-3.7-dev, libclang-3.7-dev,
-  clang-3.7, clang-format-3.7,
+  llvm-3.8-dev, libclang-3.8-dev,
+  clang-3.8, clang-format-3.8,
   libbenchmark-timer-perl, libsys-cpu-perl,
   libfile-which-perl, libregexp-common-perl, libexporter-lite-perl,
   libgetopt-tabular-perl, libterm-readkey-perl,
@@ -15,13 +15,13 @@
 # for running the tests:
   frama-c-base
 Build-Conflicts: kcc
-Standards-Version: 3.9.6
+Standards-Version: 3.9.7
 Homepage: http://embed.cs.utah.edu/creduce/
 
 Package: creduce
 Architecture: any
 Depends: ${shlibs:Depends}, ${misc:Depends},
-  clang-format-3.7,
+  clang-format-3.8,
   libbenchmark-timer-perl, libsys-cpu-perl,
   libfile-which-perl, libregexp-common-perl, libexporter-lite-perl,
   libgetopt-tabular-perl, libterm-readkey-perl,

=== debian/watch ===
version=3
http://embed.cs.utah.edu/creduce creduce-(.*)\.tar\.gz

## creduce 2.5.0

=== CMakeLists.txt ===
--- 
+++ 
@@ -27,11 +27,11 @@
 set(creduce_PACKAGE "creduce")
 set(creduce_PACKAGE_BUGREPORT "creduce-bugs@flux.utah.edu")
 set(creduce_PACKAGE_NAME "creduce")
-set(creduce_PACKAGE_STRING "creduce 2.4.0")
+set(creduce_PACKAGE_STRING "creduce 2.5.0")
 set(creduce_PACKAGE_TARNAME "creduce")
 set(creduce_PACKAGE_URL "http://embed.cs.utah.edu/creduce/")
-set(creduce_PACKAGE_VERSION "2.4.0")
-set(creduce_VERSION "2.4.0")
+set(creduce_PACKAGE_VERSION "2.5.0")
+set(creduce_VERSION "2.5.0")
 
 execute_process(COMMAND "git" "show" "-s" "--format=%h" WORKING_DIRECTORY "${CMAKE_SOURCE_DIR}" OUTPUT_VARIABLE creduce_GIT_HASH)
 string(STRIP "${creduce_GIT_HASH}" creduce_GIT_HASH)
@@ -42,8 +42,8 @@
 #endif(freeExists)
 
 if(CMAKE_CXX_COMPILER_ID STREQUAL "GNU" OR CMAKE_CXX_COMPILER_ID STREQUAL "Clang")
-  set(CMAKE_CXX_FLAGS "-std=c++11 -fno-rtti -Wall -Wextra -Wno-long-long -Wno-unused-parameter")
-  set(CMAKE_CXX_FLAGS_RELEASE "-O3 -fno-strict-aliasing")
+  set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -std=c++11 -fno-rtti -Wall -Wextra -Wno-long-long -Wno-unused-parameter")
+  set(CMAKE_CXX_FLAGS_RELEASE "${CMAKE_CXX_FLAGS_RELEASE} -O3 -fno-strict-aliasing")
 endif()
 
 #FIXME: Should be determined automatically

=== clang_delta/CMakeLists.txt ===
--- 
+++ 
@@ -1,4 +1,4 @@
-# Copyright (c) 2012, 2013, 2014, 2015 The University of Utah
+# Copyright (c) 2012, 2013, 2014, 2015, 2016 The University of Utah
 # All rights reserved.
 #
 # This file is distributed under the University of Illinois Open Source
@@ -13,8 +13,8 @@
 message(STATUS "Using LLVMConfig.cmake in: ${LLVM_DIR}")
 
 # Check LLVM version
-if (${LLVM_PACKAGE_VERSION} VERSION_LESS "3.7")
-  message(FATAL_ERROR "LLVM version must be >= 3.7")
+if (${LLVM_PACKAGE_VERSION} VERSION_LESS "3.8")
+  message(FATAL_ERROR "LLVM version must be >= 3.8")
 endif()
 set(LLVM_VERSION ${LLVM_VERSION_MAJOR}${LLVM_VERSION_MINOR})

=== debian/changelog ===
creduce (2.5.0-0ubuntu1) xenial-proposed; urgency=medium

  * SRU LP: #1585156, backport to 16.04 LTS.

 -- Matthias Klose <doko@ubuntu.com>  Tue, 24 May 2016 12:57:07 +0200

creduce (2.5.0-1) unstable; urgency=medium

  * C-Reduce 2.5.0 release.
  * Remove (build-)dependency on delta.

 -- Matthias Klose <doko@debian.org>  Tue, 24 May 2016 08:51:47 +0200

=== debian/control ===
--- 
+++ 
@@ -11,11 +11,11 @@
   libbenchmark-timer-perl, libsys-cpu-perl,
   libfile-which-perl, libregexp-common-perl, libexporter-lite-perl,
   libgetopt-tabular-perl, libterm-readkey-perl,
-  indent, astyle, delta,
+  indent, astyle,
 # for running the tests:
   frama-c-base
 Build-Conflicts: kcc
-Standards-Version: 3.9.7
+Standards-Version: 3.9.8
 Homepage: http://embed.cs.utah.edu/creduce/
 
 Package: creduce
@@ -25,7 +25,7 @@
   libbenchmark-timer-perl, libsys-cpu-perl,
   libfile-which-perl, libregexp-common-perl, libexporter-lite-perl,
   libgetopt-tabular-perl, libterm-readkey-perl,
-  indent, astyle, delta
+  indent, astyle,
 Recommends: gcc | clang
 Description: Test-Case Reduction for C Compiler Bugs
  C-Reduce is a tool which takes a large C or C++ program that has a

=== debian/rules ===
--- 
+++ 
@@ -6,7 +6,7 @@
 
 DEB_HOST_ARCH := $(shell dpkg-architecture -qDEB_HOST_ARCH)
 
-CLANG_V	= 3.7
+CLANG_V	= 3.8
 CLANG	= clang-$(CLANG_V)
 GCC	= gcc

## creduce 2.6~20160921

=== CMakeLists.txt ===
## -*- mode: CMake -*-
##
## Copyright (c) 2012, 2013, 2014, 2015, 2016 The University of Utah
## All rights reserved.
##
## This file is distributed under the University of Illinois Open Source
## License.  See the file COPYING for details.

###############################################################################

cmake_minimum_required(VERSION 2.8.12)

list(APPEND CMAKE_MODULE_PATH "${CMAKE_SOURCE_DIR}/cmake")

include(CheckIncludeFile)
include(CheckCXXCompilerFlag)
include(GetGitRevisionDescription)

project(creduce)

###############################################################################

# Locate LLVM and check its version.  Do this here because we need the LLVM
# package definitions in the "CMakeLists.txt" files for multiple subdirs.
#
find_package(LLVM REQUIRED CONFIG NO_CMAKE_BUILDS_PATH)
message(STATUS "Found LLVM ${LLVM_PACKAGE_VERSION}")
message(STATUS "Using LLVMConfig.cmake in ${LLVM_DIR}")
if (${LLVM_PACKAGE_VERSION} VERSION_LESS "3.9")
  message(FATAL_ERROR "C-Reduce requires LLVM 3.9 or later")
endif()

# Locate Perl and check its version.
#
include(FindPerl)
if(${PERL_VERSION_STRING} VERSION_LESS "5.10.0")
  message(FATAL_ERROR "C-Reduce requires Perl 5.10.0 or later")
endif()

# Locate flex.  Do this here because we need the package definitions in the
# "CMakeLists.txt" files for multiple subdirs.
#
find_package(FLEX)

###############################################################################

# Determine the short git hash for the source tree.  The logic here follows the
# logic in the `git-hash.sh` script.
#
## METHOD 1: The source tree is the result of `git archive'.
# `git archive' inserts the abbreviated hash of the archive's commit into this
# file.  (See the `.gitattributes' file.)
#
set(GIT_HASH "$Format:%h$")
if(GIT_HASH MATCHES "^\\$")
  ## METHOD 2: The source tree is a git repository.
  get_git_head_revision(GIT_REFSPEC GIT_HASH)
  if(NOT GIT_HASH STREQUAL "GITDIR-NOTFOUND")
    # Trim to the short hash.
    string(SUBSTRING "${GIT_HASH}" 0 7 GIT_HASH)
  else()
    ## METHOD 3: Give up.
    set(GIT_HASH "unknown")
  endif()
endif()

###############################################################################

# Generate the "config.h" file.
#
set(ENABLE_TRANS_ASSERT ON CACHE BOOL
  "Use assert() in clang_delta transformations.")

check_include_file("dlfcn.h"		HAVE_DLFCN_H)
check_include_file("inttypes.h"		HAVE_INTTYPES_H)
check_include_file("memory.h"		HAVE_MEMORY_H)
check_include_file("stdint.h"		HAVE_STDINT_H)
check_include_file("stdlib.h"		HAVE_STDLIB_H)
check_include_file("strings.h"		HAVE_STRINGS_H)
check_include_file("string.h"		HAVE_STRING_H)
check_include_file("sys/stat.h"		HAVE_SYS_STAT_H)
check_include_file("sys/types.h"	HAVE_SYS_TYPES_H)
check_include_file("unistd.h"		HAVE_UNISTD_H)

set(creduce_PACKAGE			"creduce")
set(creduce_PACKAGE_BUGREPORT		"creduce-bugs@flux.utah.edu")
set(creduce_PACKAGE_NAME		"creduce")
set(creduce_PACKAGE_STRING		"creduce 2.6.0")
set(creduce_PACKAGE_TARNAME		"creduce")
set(creduce_PACKAGE_URL			"http://embed.cs.utah.edu/creduce/")
set(creduce_PACKAGE_VERSION		"2.6.0")
set(creduce_VERSION			"2.6.0")

# FIXME: Should be determined automatically.
set(YYTEXT_POINTER 1)

configure_file("cmake_config.h.in" "${PROJECT_BINARY_DIR}/config.h")
add_definitions("-DHAVE_CONFIG_H")

###############################################################################

# Use option `-fvisibility-inlines-hidden` if the C++ compiler supports it.
# See LLVM file `share/llvm/cmake/HandleLLVMOptions.cmake`.
#
check_cxx_compiler_flag(
  "-fvisibility-inlines-hidden"
  SUPPORTS_FVISIBILITY_INLINES_HIDDEN_FLAG
  )

if(CMAKE_CXX_COMPILER_ID STREQUAL "GNU"
    OR CMAKE_CXX_COMPILER_ID STREQUAL "Clang")
  # XXX figure out how to get "-std=c++11 -fno-rtti" from LLVM.  That's how we
  # get those options in the Automake path...
  set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -std=c++11 -fno-rtti -fno-strict-aliasing -Wall -Wextra -Wno-long-long -Wno-unused-parameter -Wno-missing-field-initializers")
  if(SUPPORTS_FVISIBILITY_INLINES_HIDDEN_FLAG)
    set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -fvisibility-inlines-hidden")
  endif()
  set(CMAKE_CXX_FLAGS_RELEASE "${CMAKE_CXX_FLAGS_RELEASE} -O3")
endif()

###############################################################################

add_subdirectory(clang_delta)
add_subdirectory(clex)
add_subdirectory(creduce)
add_subdirectory(delta)
# `unifdef' requires a Unix-y platform.
if(UNIX)
  add_subdirectory(unifdef)
else()
  message(WARNING
    "Internal tool `unifdef${CMAKE_EXECUTABLE_SUFFIX}' cannot be compiled on this OS; skipping.")
endif()

###############################################################################

## End of file.

=== clang_delta/CMakeLists.txt ===
## -*- mode: CMake -*-
##
## Copyright (c) 2012, 2013, 2014, 2015, 2016 The University of Utah
## All rights reserved.
##
## This file is distributed under the University of Illinois Open Source
## License.  See the file COPYING for details.

###############################################################################

cmake_minimum_required(VERSION 2.8.12)
project(clang_delta)

###############################################################################

# find_package(LLVM) is done by the topmost "CMakeLists.txt" file.

# Generate file "git_version.cpp".
#
configure_file("git_version.cpp.in" "git_version.cpp" @ONLY)

# Add flags for compiling against LLVM.
#
add_definitions(${LLVM_DEFINITIONS})
set_property(DIRECTORY APPEND PROPERTY COMPILE_DEFINITIONS
  $<$<CONFIG:Release>:NDEBUG>)
# include_directories(${PROJECT_BINARY_DIR}) --- if we generated .h files here
include_directories(${CMAKE_BINARY_DIR})
include_directories(${PROJECT_SOURCE_DIR}) # needed for gen'ed .cpp files
include_directories(${LLVM_INCLUDE_DIRS})
link_directories(${LLVM_LIBRARY_DIRS})

llvm_map_components_to_libnames(LLVM_LIBS
  irreader
  mcparser
  option
  profiledata
)

set(CLANG_LIBS
  clangStaticAnalyzerFrontend
  clangStaticAnalyzerCheckers
  clangStaticAnalyzerCore
  clangFrontendTool
  clangFrontend
  clangDriver
  clangSerialization
  clangCodeGen
  clangParse
  clangSema
  clangAnalysis
  clangRewriteFrontend
  clangRewrite
  clangAST
  clangBasic
  clangEdit
  clangLex
)

add_executable(clang_delta
  ${CMAKE_BINARY_DIR}/config.h
  AggregateToScalar.cpp
  AggregateToScalar.h
  BinOpSimplification.cpp
  BinOpSimplification.h
  CallExprToValue.cpp
  CallExprToValue.h
  ClangDelta.cpp
  ClassTemplateToClass.cpp
  ClassTemplateToClass.h
  CombineGlobalVarDecl.cpp
  CombineGlobalVarDecl.h
  CombineLocalVarDecl.cpp
  CombineLocalVarDecl.h
  CommonParameterRewriteVisitor.h
  CommonRenameClassRewriteVisitor.h
  CommonStatementVisitor.h
  CommonTemplateArgumentVisitor.h
  CopyPropagation.cpp
  CopyPropagation.h
  EmptyStructToInt.cpp
  EmptyStructToInt.h
  ExpressionDetector.cpp
  ExpressionDetector.h
  InstantiateTemplateParam.cpp
  InstantiateTemplateParam.h
  InstantiateTemplateTypeParamToInt.cpp
  InstantiateTemplateTypeParamToInt.h
  LiftAssignmentExpr.cpp
  LiftAssignmentExpr.h
  LocalToGlobal.cpp
  LocalToGlobal.h
  MoveFunctionBody.cpp
  MoveFunctionBody.h
  MoveGlobalVar.cpp
  MoveGlobalVar.h
  ParamToGlobal.cpp
  ParamToGlobal.h
  ParamToLocal.cpp
  ParamToLocal.h
  ReduceArrayDim.cpp
  ReduceArrayDim.h
  ReduceArraySize.cpp
  ReduceArraySize.h
  ReduceClassTemplateParameter.cpp
  ReduceClassTemplateParameter.h
  ReducePointerLevel.cpp
  ReducePointerLevel.h
  ReducePointerPairs.cpp
  ReducePointerPairs.h
  RemoveAddrTaken.cpp
  RemoveAddrTaken.h
  RemoveArray.cpp
  RemoveArray.h
  RemoveBaseClass.cpp
  RemoveBaseClass.h
  RemoveCtorInitializer.cpp
  RemoveCtorInitializer.h
  RemoveEnumMemberValue.cpp
  RemoveEnumMemberValue.h
  RemoveNamespace.cpp
  RemoveNamespace.h
  RemoveNestedFunction.cpp
  RemoveNestedFunction.h
  RemovePointer.cpp
  RemovePointer.h
  RemoveTrivialBaseTemplate.cpp
  RemoveTrivialBaseTemplate.h
  RemoveUnresolvedBase.cpp
  RemoveUnresolvedBase.h
  RemoveUnusedEnumMember.cpp
  RemoveUnusedEnumMember.h
  RemoveUnusedFunction.cpp
  RemoveUnusedFunction.h
  RemoveUnusedOuterClass.cpp
  RemoveUnusedOuterClass.h
  RemoveUnusedStructField.cpp
  RemoveUnusedStructField.h
  RemoveUnusedVar.cpp
  RemoveUnusedVar.h
  RenameCXXMethod.cpp
  RenameCXXMethod.h
  RenameClass.cpp
  RenameClass.h
  RenameFun.cpp
  RenameFun.h
  RenameParam.cpp
  RenameParam.h
  RenameVar.cpp
  RenameVar.h
  ReplaceArrayAccessWithIndex.cpp
  ReplaceArrayAccessWithIndex.h
  ReplaceArrayIndexVar.cpp
  ReplaceArrayIndexVar.h
  ReplaceCallExpr.cpp
  ReplaceCallExpr.h
  ReplaceClassWithBaseTemplateSpec.cpp
  ReplaceClassWithBaseTemplateSpec.h
  ReplaceDependentName.cpp
  ReplaceDependentName.h
  ReplaceDependentTypedef.cpp
  ReplaceDependentTypedef.h
  ReplaceDerivedClass.cpp
  ReplaceDerivedClass.h
  ReplaceFunctionDefWithDecl.cpp
  ReplaceFunctionDefWithDecl.h
  ReplaceOneLevelTypedefType.cpp
  ReplaceOneLevelTypedefType.h
  ReplaceSimpleTypedef.cpp
  ReplaceSimpleTypedef.h
  ReplaceUndefinedFunction.cpp
  ReplaceUndefinedFunction.h
  ReturnVoid.cpp
  ReturnVoid.h
  RewriteUtils.cpp
  RewriteUtils.h
  SimpleInliner.cpp
  SimpleInliner.h
  SimplifyCallExpr.cpp
  SimplifyCallExpr.h
  SimplifyCommaExpr.cpp
  SimplifyCommaExpr.h
  SimplifyDependentTypedef.cpp
  SimplifyDependentTypedef.h
  SimplifyIf.cpp
  SimplifyIf.h
  SimplifyNestedClass.cpp
  SimplifyNestedClass.h
  SimplifyRecursiveTemplateInstantiation.cpp
  SimplifyRecursiveTemplateInstantiation.h
  SimplifyStruct.cpp
  SimplifyStruct.h
  SimplifyStructUnionDecl.cpp
  SimplifyStructUnionDecl.h
  TemplateArgToInt.cpp
  TemplateArgToInt.h
  TemplateNonTypeArgToInt.cpp
  TemplateNonTypeArgToInt.h
  Transformation.cpp
  Transformation.h
  TransformationManager.cpp
  TransformationManager.h
  UnifyFunctionDecl.cpp
  UnifyFunctionDecl.h
  UnionToStruct.cpp
  UnionToStruct.h
  VectorToArray.cpp
  VectorToArray.h
  ${PROJECT_BINARY_DIR}/git_version.cpp
  git_version.h
)

target_link_libraries(clang_delta ${CLANG_LIBS} ${LLVM_LIBS})

install(TARGETS clang_delta
  RUNTIME DESTINATION "libexec"
)
# If binary is read-only, then installing may fail with an error:
# CMake Error at cmake_install.cmake:45 (FILE):
#  file RPATH_REMOVE could not remove RPATH from file:
#    /disk2/randtest/install/libexec/clang_delta
#  Error opening file for update.
#
# Do I want RPATH at all?  We can turn it off, by setting CMAKE_SKIP_RPATH
# https://cmake.org/cmake/help/v2.8.8/cmake.html#variable%3aCMAKE_SKIP_RPATH
# See also the stuff about RPATH for `set_target_properties', which I don't
# really grok:
# https://cmake.org/cmake/help/v2.8.8/cmake.html#command:set_target_properties
#
#  PERMISSIONS
#    OWNER_READ OWNER_EXECUTE GROUP_READ GROUP_EXECUTE WORLD_READ WORLD_EXECUTE

###############################################################################

## End of file.

=== debian/changelog ===
creduce (2.6~20160921-1) unstable; urgency=medium

  * Upstream snapshot, taken from master.
  * Drop indent and astyle (build-)dependencies.
  * Build using llvm-3.9.

 -- Matthias Klose <doko@debian.org>  Wed, 21 Sep 2016 15:08:51 +0200

=== debian/control ===
--- 
+++ 
@@ -6,12 +6,11 @@
 Build-Depends: debhelper (>= 9), autotools-dev,
   flex,
   libedit-dev, zlib1g-dev,
-  llvm-3.8-dev, libclang-3.8-dev,
-  clang-3.8, clang-format-3.8,
+  llvm-3.9-dev, libclang-3.9-dev,
+  clang-3.9, clang-format-3.9,
   libbenchmark-timer-perl, libsys-cpu-perl,
   libfile-which-perl, libregexp-common-perl, libexporter-lite-perl,
   libgetopt-tabular-perl, libterm-readkey-perl,
-  indent, astyle,
 # for running the tests:
   frama-c-base
 Build-Conflicts: kcc
@@ -21,11 +20,10 @@
 Package: creduce
 Architecture: any
 Depends: ${shlibs:Depends}, ${misc:Depends},
-  clang-format-3.8,
+  clang-format-3.9,
   libbenchmark-timer-perl, libsys-cpu-perl,
   libfile-which-perl, libregexp-common-perl, libexporter-lite-perl,
   libgetopt-tabular-perl, libterm-readkey-perl,
-  indent, astyle,
 Recommends: gcc | clang
 Description: Test-Case Reduction for C Compiler Bugs
  C-Reduce is a tool which takes a large C or C++ program that has a

=== debian/rules ===
--- 
+++ 
@@ -6,7 +6,7 @@
 
 DEB_HOST_ARCH := $(shell dpkg-architecture -qDEB_HOST_ARCH)
 
-CLANG_V	= 3.8
+CLANG_V	= 3.9
 CLANG	= clang-$(CLANG_V)
 GCC	= gcc

## creduce 2.6.0

=== CMakeLists.txt ===
--- 
+++ 
@@ -51,7 +51,7 @@
 # `git archive' inserts the abbreviated hash of the archive's commit into this
 # file.  (See the `.gitattributes' file.)
 #
-set(GIT_HASH "$Format:%h$")
+set(GIT_HASH "b02c375")
 if(GIT_HASH MATCHES "^\\$")
   ## METHOD 2: The source tree is a git repository.
   get_git_head_revision(GIT_REFSPEC GIT_HASH)

=== clang_delta/CMakeLists.txt ===
--- 
+++ 
@@ -31,10 +31,14 @@
 link_directories(${LLVM_LIBRARY_DIRS})
 
 llvm_map_components_to_libnames(LLVM_LIBS
+  coverage
   irreader
   mcparser
+  objcarcopts
   option
+  passes
   profiledata
+  support
 )
 
 set(CLANG_LIBS
@@ -55,6 +59,7 @@
   clangBasic
   clangEdit
   clangLex
+  clangARCMigrate
 )
 
 add_executable(clang_delta
@@ -212,6 +217,12 @@
 
 target_link_libraries(clang_delta ${CLANG_LIBS} ${LLVM_LIBS})
 
+# On Windows, we also need to link with "Version.dll" system library.
+# See <https://github.com/csmith-project/creduce/pull/126>.
+if("${CMAKE_SYSTEM_NAME}" STREQUAL "Windows")
+  target_link_libraries(clang_delta Version)
+endif()
+
 install(TARGETS clang_delta
   RUNTIME DESTINATION "libexec"
 )

=== debian/changelog ===
creduce (2.6.0-1) unstable; urgency=medium

  * C-Reduce 2.6.0 release.

 -- Matthias Klose <doko@debian.org>  Sun, 08 Jan 2017 22:55:38 +0100

## creduce 2.7~20170317

=== CMakeLists.txt ===
--- 
+++ 
@@ -1,6 +1,6 @@
 ## -*- mode: CMake -*-
 ##
-## Copyright (c) 2012, 2013, 2014, 2015, 2016 The University of Utah
+## Copyright (c) 2012, 2013, 2014, 2015, 2016, 2017 The University of Utah
 ## All rights reserved.
 ##
 ## This file is distributed under the University of Illinois Open Source
@@ -26,9 +26,14 @@
 find_package(LLVM REQUIRED CONFIG NO_CMAKE_BUILDS_PATH)
 message(STATUS "Found LLVM ${LLVM_PACKAGE_VERSION}")
 message(STATUS "Using LLVMConfig.cmake in ${LLVM_DIR}")
-if (${LLVM_PACKAGE_VERSION} VERSION_LESS "3.9")
-  message(FATAL_ERROR "C-Reduce requires LLVM 3.9 or later")
+if (${LLVM_PACKAGE_VERSION} VERSION_LESS "4.0")
+  message(FATAL_ERROR "C-Reduce requires LLVM 4.0 or later")
 endif()
+#
+# Do this here, too, just to keep it with the LLVM check above.
+#
+find_package(Clang REQUIRED CONFIG NO_CMAKE_BUILDS_PATH)
+message(STATUS "Using ClangConfig.cmake in ${Clang_DIR}")
 
 # Locate Perl and check its version.
 #
@@ -51,7 +56,7 @@
 # `git archive' inserts the abbreviated hash of the archive's commit into this
 # file.  (See the `.gitattributes' file.)
 #
-set(GIT_HASH "b02c375")
+set(GIT_HASH "$Format:%h$")
 if(GIT_HASH MATCHES "^\\$")
   ## METHOD 2: The source tree is a git repository.
   get_git_head_revision(GIT_REFSPEC GIT_HASH)
@@ -85,11 +90,11 @@
 set(creduce_PACKAGE			"creduce")
 set(creduce_PACKAGE_BUGREPORT		"creduce-bugs@flux.utah.edu")
 set(creduce_PACKAGE_NAME		"creduce")
-set(creduce_PACKAGE_STRING		"creduce 2.6.0")
+set(creduce_PACKAGE_STRING		"creduce 2.7.0")
 set(creduce_PACKAGE_TARNAME		"creduce")
 set(creduce_PACKAGE_URL			"http://embed.cs.utah.edu/creduce/")
-set(creduce_PACKAGE_VERSION		"2.6.0")
-set(creduce_VERSION			"2.6.0")
+set(creduce_PACKAGE_VERSION		"2.7.0")
+set(creduce_VERSION			"2.7.0")
 
 # FIXME: Should be determined automatically.
 set(YYTEXT_POINTER 1)

=== debian/changelog ===
creduce (2.7~20170317-1) unstable; urgency=medium

  * Upstream snapshot, taken from master.
  * Build using llvm-4.0.

 -- Matthias Klose <doko@debian.org>  Fri, 17 Mar 2017 11:49:02 +0100

=== debian/rules ===
--- 
+++ 
@@ -6,7 +6,7 @@
 
 DEB_HOST_ARCH := $(shell dpkg-architecture -qDEB_HOST_ARCH)
 
-CLANG_V	= 3.9
+CLANG_V	= 4.0
 CLANG	= clang-$(CLANG_V)
 GCC	= gcc

## creduce 2.7.0

=== CMakeLists.txt ===
--- 
+++ 
@@ -56,7 +56,7 @@
 # `git archive' inserts the abbreviated hash of the archive's commit into this
 # file.  (See the `.gitattributes' file.)
 #
-set(GIT_HASH "$Format:%h$")
+set(GIT_HASH "c0c7f0b")
 if(GIT_HASH MATCHES "^\\$")
   ## METHOD 2: The source tree is a git repository.
   get_git_head_revision(GIT_REFSPEC GIT_HASH)

=== clang_delta/CMakeLists.txt ===
--- 
+++ 
@@ -1,6 +1,6 @@
 ## -*- mode: CMake -*-
 ##
-## Copyright (c) 2012, 2013, 2014, 2015, 2016 The University of Utah
+## Copyright (c) 2012, 2013, 2014, 2015, 2016, 2017 The University of Utah
 ## All rights reserved.
 ##
 ## This file is distributed under the University of Illinois Open Source
@@ -14,6 +14,7 @@
 ###############################################################################
 
 # find_package(LLVM) is done by the topmost "CMakeLists.txt" file.
+# find_package(Clang) is done by the topmost "CMakeLists.txt" file.
 
 # Generate file "git_version.cpp".
 #
@@ -28,6 +29,8 @@
 include_directories(${CMAKE_BINARY_DIR})
 include_directories(${PROJECT_SOURCE_DIR}) # needed for gen'ed .cpp files
 include_directories(${LLVM_INCLUDE_DIRS})
+include_directories(${CLANG_INCLUDE_DIRS}) # only works for LLVM post-4.0
+
 link_directories(${LLVM_LIBRARY_DIRS})
 
 llvm_map_components_to_libnames(LLVM_LIBS

=== debian/changelog ===
creduce (2.7.0-1) unstable; urgency=medium

  * C-Reduce 2.7.0 release.

 -- Matthias Klose <doko@debian.org>  Sun, 21 May 2017 14:12:57 -0700

=== debian/control ===
--- 
+++ 
@@ -6,8 +6,8 @@
 Build-Depends: debhelper (>= 9), autotools-dev,
   flex,
   libedit-dev, zlib1g-dev,
-  llvm-3.9-dev, libclang-3.9-dev,
-  clang-3.9, clang-format-3.9,
+  llvm-4.0-dev, libclang-4.0-dev,
+  clang-4.0, clang-format-4.0,
   libbenchmark-timer-perl, libsys-cpu-perl,
   libfile-which-perl, libregexp-common-perl, libexporter-lite-perl,
   libgetopt-tabular-perl, libterm-readkey-perl,
@@ -20,7 +20,7 @@
 Package: creduce
 Architecture: any
 Depends: ${shlibs:Depends}, ${misc:Depends},
-  clang-format-3.9,
+  clang-format-4.0,
   libbenchmark-timer-perl, libsys-cpu-perl,
   libfile-which-perl, libregexp-common-perl, libexporter-lite-perl,
   libgetopt-tabular-perl, libterm-readkey-perl,
